% rethorical_acts: Rhetorical acts for Universum-Golem
% Copyright (c) 2007-2008 Luis Pineda (http://leibniz.iimas.unam.mx/~luis)
% Copyright (c) 2009-     Luis Pineda (http://leibniz.iimas.unam.mx/~luis), 
%                         Elia Pavon ()
%                         Ivan Meza (http://turing.iimas.unam.mx/~ivanvladimir)

rht_act_realization([]).

%motor speech act (control to motor state)
rht_act_realization([Rht_Act|T]) :-
	    Rht_Act =.. [ma|_],

	    %consult paths between dialogue ports
        (mode_exe(test) ->
	        print('execute_motor_act: '),print(Rht_Act),nl
        | otherwise -> 
    	    paths(Paths_Dialogue),
	        move_robot(Rht_Act, Paths_Dialogue)
        ),

	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).



% Despliega imagen: acto rht. "despliega(imagen_ID"
rht_act_realization([despliega(I,X)|T]) :-
	    %aqui se llama agente de OAA que despliega la imagen
        (mode_exe(test) ->
            print('Visualiza imagen: '),print(I),print(', '),print(X),nl
        | otherwise -> 
	        oaa_Solve(visualizaImagen(I,X),[])
        ),



	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).

% Espera respuesta para iniciar juego: acto rht. "espera_respuesta( imagen_boton)
rht_act_realization([espera_respuesta(I)|T]) :-

	    %aqui se llama agente de OAA que despliega la imagen
        (mode_exe(test) ->
            print('Esperar por respuesta del elemento ['),
            print(I),
            print('] teclee "ok." para continuar'),print(I),nl,
            read(E)
        | otherwise -> 
	        oaa_Solve(espera_respuesta(I),[])
        ),

	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).

% Tomar foto al participante: acto rht. "toma_foto(tiempo [ms])"
rht_act_realization([toma_foto(I)|T]) :-
        (mode_exe(test) ->
            print('Toma foto '),nl
        | otherwise -> 
	        oaa_Solve(toma_foto(I),[])
        ),

	    %aqui se llama agente de OAA que despliega la imagen

	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).

% Despliega video: acto rht. "despliega_video(imagen_ID"
rht_act_realization([despliega_video(I)|T]) :-

	    %aqu se llama agente de OAA que despliega la imagen
	    (mode_exe(test) ->
            print('Visualiza video: '),print(I),nl
        | otherwise -> 
	        oaa_Solve(visualizaVideo(I,Y),[])
        ),

  
	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).

% Tomar foto al participante: acto rht. "cheese(tiempo [ms])"
rht_act_realization([cheese(I)|T]) :-
        (mode_exe(test) ->
            print('Cheese...'),nl
        | otherwise -> 
            oaa_Solve(cheese(I),[blocking(true)])
        ),!,


        %aqui se llama agente de OAA que toma la foto

        %realiza siguiente acto retrico bsico
        rht_act_realization(T).



% Muestra ves: acto rht. "toma_foto()"
rht_act_realization([muestra_ves(I)|T]) :-
	    %aqu se llama agente de OAA que muestra lo que ve
        (mode_exe(test) ->
            print('uuestra lo que vi golem: '),nl
        | otherwise -> 
	        oaa_Solve(visualizaVeGolem(I,Y),[])
        ),

	    %realiza siguiente acto retrico bsico
	    rht_act_realization(T).



% Realiza acto retrico textual
rht_act_realization([H|T]) :-
	    %realiza acto retrico bsico como texto
	    gen_text(H,Text),
        (mode_exe(test) ->
            print('Golem dice: '), print(Text),nl
        | otherwise -> 
	        oaa_Solve(di(Text,_X),[blocking(true)])
        ),
	    %aqui se llama al sintetizador de voz
		    
	    rht_act_realization(T).


%Utilities for Template realizations
realize_list([],_,[]).
realize_list([H|[]],_,L1) :- get_text(H, Text), name(Text, L1).
realize_list([H|T],CONJ, Out_List) :-
	    length_list(T, 1),
	    get_text(H, Text1),
	    name(Text1, L1),
	    name(' ', L2),
	    append(L1, L2, L3),
	    name(CONJ, L4),
	    append(L3, L4, L5),
	    realize_list(T,_, L6),
	    append(L5, L6, Out_List).

realize_list([H|T], CONJ, Out_List) :-
	    get_text(H, Text1),
            name(Text1, L1),
	    name(', ', L2),
	    append(L1, L2, L3),
	    realize_list(T, CONJ, Rest_List),
	    append(L3, Rest_List, Out_List).

get_text(ID, Text) :-
	    rht_act_IDs(Translations),
	    get_text_translation(ID,Translations,Text).

get_text_translation(_,[],error) :- fail.
	  % print('translation error: no such text '),nl.
get_text_translation(ID,[ID => Text|_],Text).
get_text_translation(ID,[_|T],Text) :-
	   get_text_translation(ID,T,Text).


