% card.dm: Dialogue for a chosen card
% Copyright (c) 2007-2008 Luis Pineda (http://leibniz.iimas.unam.mx/~luis)
% Copyright (c) 2009-     Luis Pineda (http://leibniz.iimas.unam.mx/~luis), 
%                         Elia Patricia Pavon  ()
%                         Ivan Meza   (http://turing.iimas.unam.mx/~ivanvladimir)

diag_mod(card(Carta),
	[
	 	% Inicio del dialogo, anuncia que esta listo para escuchar
        [id ==> is,
         type ==> neutral,
         in_pairs ==> [empty => empty:empty],
         out_pairs ==> [empty:ra_1 => ls_1]
        ],

        % Espera una pregunta sobre caracteristica, carta o algo repetido
		[id ==> ls_1,
         type ==> listening,
         out_pairs ==> [caracteristica(X):apply(eval_pregunta,[Carta, X, ra_2]) => ts_1,
				        carta(Y):ra_3(Y) => ls_2,
				        repetida:ra_4(repetida) => ls_1]
		 ],

        % Avisa que puede preguntar, que le queda otra pregunta y que ya no
        % quedam preguntas
		[id ==> ts_1,
		 type ==> neutral,
		 out_pairs ==> [empty:apply(get_rht_act,[ra_5_0, ra_5_1, ra_5_2]) => apply(next_sit,[ls_1, ss_1])]
		],

        % Espera que le confirmen que le mostraran la carta
		[id ==> ls_2,
		 type ==> listening,
		 out_pairs ==> [ ok:ra_6(muestra) => ss_1,  
				         no:ra_ex => ts_1]
		],

		% Reconociendo la tarjeta a traves de la camara
		[id ==> ss_1,
		 type ==> seeing,
		 out_pairs ==> [carta(Carta_vista):ra_7(Carta_vista) => ls_3(Carta_vista)]
		],		

		% Espera que se confirme la carta vista
        [id ==> ls_3(Carta_vista),
		 type ==> listening,
		 out_pairs ==> [ ok:apply(get_rht_carta,[ra_8, ra_9,Carta_vista,Carta]) => fs,
				         no:ra_6(muestra_otra) => ss_1]
		],		

        % Fin del dialogo
		[id ==> fs,
                 type ==> final,
                 %in_pairs ==> [ls_1 => no:ra_3],
                 out_pairs ==> [_ => []]
        ],

        % Error
        [id ==> unexpected_speech_act,
                 type ==> error,
                 in_pairs ==> [Previous_Situation => In_Trans],
                 out_pairs ==> [In_Pair => Previous_Situation]
        ]
        ],

	%Actos retoricos.
	[
        % Pedi la pregunta	
		[id ==> ra_1,
         type ==> peticion,
         rht_acts ==> [ pide_pregunta]
        ],

        % Nos dice si la pregunta es positiva o negativa
		[id ==> ra_2(Imagen,Valor,Carta),
         type ==> descripcion,
         rht_acts ==> [ despliega(Imagen,''),
                        caption(Imagen, Valor,Carta )]
        ],

        % Pregunta si es la carta
		[id ==> ra_3(Concepto),
         type ==> pregunta,
         pars ==> [Concepto],
         rht_acts ==> [despliega('duda',''), 
                       caption(Concepto, pregunta)]
        ],
		
        % Dice que  la pregunta ya fue echa
		[id ==> ra_4(Repetida),
         type ==> peticion,
         rht_acts ==> [ Repetida]
        ],
	
        % Imforma que queda otra pregunta
		[id ==> ra_5_0,
         type ==> peticion,
         rht_acts ==> [ otra_pregunta]
        ],

        % Informa que es la ultima pregunta
		[id ==> ra_5_1,
         type ==> peticion,
         rht_acts ==> [ ultima_pregunta]
        ],

        % Informa que no quedan mas preguntas y pide que muestre su carta
		[id ==> ra_5_2,
         type ==> peticion,
         rht_acts ==> [ no_mas_preguntas,
		 despliega('muestra','')]
        ],

        % Muestra el cocpetp
		[id ==> ra_6(Concepto),
         type ==> peticion,
         rht_acts ==> [
            despliega(Concepto,''),
            caption(Concepto)]
        ],

        % Despliega la carta vista
 		[id ==> ra_7(Carta_vista),
         type ==> check,
         rht_acts ==> [despliega(Carta_vista,''), caption(confirma_carta)]
        ],
		
        % Inform que gano
		[id ==> ra_8(Carta,Valor),
         type ==> despedida,
         rht_acts ==> [
            despliega(Carta,''), 
            Carta, 
            despliega('gana','')]
        ],

        % Informa que perdio
		[id ==> ra_9(Carta_adivinada,Valor),
         type ==> despedida,
         rht_acts ==> [
            despliega(Carta_adivinada,''), 
            caption(Carta_adivinada, Valor), 
            era(Carta), despliega(Carta,'')]
        ],

        % Informa que tiene una oportunidad para adivinar
		[id ==> ra_ex,
         type ==> confirmacion,
         pars ==> [],
         rht_acts ==> [una_oportunidad]
        ],
		
        % Error
		[id ==> error(Concepto),
         type ==> correction,
         rht_acts ==> [error(Concept)]
         ]
		
	]
). %fin dialogo de radio
