% main.dm: Main dialogue for Golem-universum
% Copyright (c) 2007-2008 Luis Pineda (http://leibniz.iimas.unam.mx/~luis)
% Copyright (c) 2009-     Luis Pineda (http://leibniz.iimas.unam.mx/~luis), 
%                         Elia Patricia Pavon  ()
%                         Ivan Meza   (http://turing.iimas.unam.mx/~ivanvladimir)

diag_mod(main,
    % Situaciones
    [   %Empieza el juego
        % Se presenta y pregunta por nombre
        [id ==> is,
         type ==> neutral,
         out_pairs ==> [empty:ra_0 => ls_0]
        ],

        % Espera nombre usuario y pregunta por edad
        [id ==> ls_0,
         type ==> listening,
         out_pairs ==> [nombre(N):ra_1(N) => ls_1]
        ],

        % Espera edad, checa que sea una edad valida
        % Edad valida: pregunta si quiere escuchar por instruacciones
        % Edad invalida: dice que lo siente y termina el juego
        [id ==> ls_1,
         type ==> listening,
         out_pairs ==> [edad(X):apply(age_check,[X,ra_1_1,ra_1_2]) => apply(age_check,[X,ls_2,fs])]
        ],

        % Espera por respuesta a querer escuchar instrucciones,
        % si: dice las respuestas y pregunta si entendio
        % no: empieza el juego y selecciona carta
        [id ==> ls_2,
         type ==> listening,
         out_pairs ==> [ok:ra_3 => ls_3,
                        no:ra_2(confirma_empieza) =>
                            apply(get_random_topic,[ja_cartas(CARTAS),CARTAS,rs_1])]
        ],

        % Espera por respueta a si entendio las instrucciones
        % si: empieza el juego y pregunta si entencio
        % no: repite instrucciones
        [id ==> ls_3,
         type ==> listening,
         out_pairs ==> [ok:ra_2(confirma_empieza2) =>
                                apply(get_random_topic,[ja_cartas(CARTAS),CARTAS,rs_1]),
                        no:ra_5 => ls_3]
        ],

        % Ejecuta el subdialogo para la carta deseada
        [id ==> rs_1(Model),
         type ==> recursive(card(Model)),
         out_pairs ==> [empty:ra_4 => fs]
        ],

        % Termina el juego
        [id ==> fs,
         type ==> final,
         out_pairs ==> [_ => []]
        ],
        
        % En caso de error
        [id ==> unexpected_speech_act,
                 type ==> error,
                 in_pairs ==> [Previous_Situation => In_Trans],
                 out_pairs ==> [In_Trans => Previous_Situation]
        ]
    ],

    %Actos retoricos
    [
        % Se presenta y pregunta el nombre del niño
        [id ==> ra_0,
         type ==> introduccion,
         rht_acts ==> [
                despliega('logo',''),
                espera_respuesta('boton_JuegoAdivina'),
                %despliega_video('fin','00#00#10'),
                despliega('saludo',''),
                saludo,
                jugador,
                pide_nombre]
        ],

        % Saluda y pide edad
        [id ==> ra_1(Nombre),
         type ==> introduccion,
         rht_acts ==> [ 
                despliega('hola',''),
                hola(Nombre),
                pide_edad]
        ],

        % Pregunta si quiere jugar 
        [id ==> ra_1_1,
         type ==> introduccion,
         rht_acts ==> [ 
                despliega('puede_jugar',''),
                puede_jugar,
                opcion_s_n('que te explique','las reglas del juego')]
        ],

        % Dice que no puede jugar y se despide
        [id ==> ra_1_2,
         type ==> introduccion,
         rht_acts ==> [ 
                despliega('no_puede_jugar',''),
                no_puede_jugar,
                despedida]
        ],

        % Comienza el juego
        [id ==> ra_2(Valor),
         type ==> confirmacion,
         rht_acts ==> [caption(Valor),
                   empieza]
        ],

        % Explica el juego
        [id ==> ra_3,
         type ==> explicacion,
         rht_acts ==> [
                despliega('bienvenida',''),
                explica,
                despliega('cartas',''),
                explica2,
                explica3,
                explica4,
                despliega('color',''),
                explica5,
                despliega('forma',''),
                explica6,
                despliega('tamano',''),
                explica7,
                despliega('ejemplo_preguntas',''),
                explica8,
                pregunta_entiendes]
        ],

        % Se despide 
        [id ==> ra_4,
         type ==> despedida,
         rht_acts ==> [ 
                tomaFoto, sonrie,
                cheese('listo'), 
                adios]
        ],

        % Se despide por segunda ocación
        [id ==> ra_5,
         type ==> explicacion,
         rht_acts ==> [
                otra_explica,
                despliega('cartas',''),
                otra_explica2,
                despliega('ejemplo_preguntas',''),
                otra_explica3,
                pregunta_entiendes]
        ],

        % No entendio lo que dices
        [id ==> error(Concept),
                 type ==> correction,
                 rht_acts ==> [error(Concept)]
        ]
    ]
). %fin dialogo
