% read_input: Read prolog files
% Copyright (c) 2004-  Luis Pineda (http://leibniz.iimas.unam.mx/~luis)

:- use_module(library(charsio)).

%lee file con file IDs, y crea una lista con todas las clausulas en todos los files IDs.
load_list_of_files(ProjDir,Files_ids, Clause_List) :-
			load_file(ProjDir,Files_ids, Files_List),
			get_clauses_files(ProjDir,Files_List, Clause_List).

get_clauses_files(ProjDir,[], Clauses_List).
get_clauses_files(ProjDir,[H|T], Clause_List) :-
			load_file(ProjDir,H, Clauses_File),
			get_clauses_files(ProjDir,T, Rest_Clauses),
			append(Clauses_File, Rest_Clauses, Clause_List).
			

%lee file de clausulas en una lista
load_file(ProjDir,RULES,CLAUSE_LIST) :-
    seeing(IN),
    absolute_file_name(RULES,RULES2,[relative_to(ProjDir)]),
    see(RULES2),
    read_clause([],CLAUSE_LIST),
    seen,
    see(IN),
    !.

read_clause(INLIST,OUTLIST) :-
    read(TERM),
    next_term(TERM,INLIST,OUTLIST).

next_term(end_of_file,L,L).
next_term(TERM,INLIST,OUTLIST) :-
    append(INLIST,[TERM],LIST),
    read_clause(LIST,OUTLIST).


update_nl(STR) :- 
    build_term(TERM,STR),
    new_fact(TERM).


%creacion de ambiente de evaluacion
create_env([]).
create_env([H|T]) :-
	assert(H),
	create_env(T),
	!.

%compile an atom string of characters as a prolog term
atom_to_term(ATOM, TERM) :-
     atom(ATOM),
     atom_to_chars(ATOM,STR),
     atom_to_chars('.',PTO),
     append(STR,PTO,STR_PTO),
     read_from_chars(STR_PTO,TERM).

%compile a string of characters as a prolog term
build_term(TERM,STR) :-
            telling(OUT),
            seeing(IN),
            name(ATOM,STR),
            tell('/tmp/gk_junk'),
            write(ATOM),
            write('.'),
            nl,
            told,
            see('/tmp/gk_junk'),
            read(TERM),
            seen,
            see(IN),
            tell(OUT),
            rename('/tmp/gk_junk',[]),
            !.

